package com.wistone.pay.net.http;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.HttpVersion;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import android.text.TextUtils;

/**************************************************************************
 * HttpClient</br>
 * Author : isUseful ? TanJian : Unknown</br>
 * English by google translate.
 **************************************************************************/
public class CommandHttpClient
{
	private static final Object	lock					= new Object();
	private static final int	MAX_TOTAL_CONNECTIONS	= 200;
	private static final int	CONNMANAGER_TIMEOUT		= 2 * 1000;
	private static final int	CONN_TIMEOUT			= 30 * 1000;
	private static final int	SO_TIMEOUT				= 6 * 1000;
	private static HttpClient	httpClient;

	public static HttpClient getHttpClient() throws Exception
	{
		if (httpClient == null)
		{
			synchronized (lock)
			{
				if (httpClient == null)
				{
					HttpParams params = new BasicHttpParams();
					// params.setParameter(CoreConnectionPNames.TCP_NODELAY, true);

					HttpProtocolParams.setVersion(params, HttpVersion.HTTP_1_1);
					HttpProtocolParams.setContentCharset(params, HTTP.UTF_8);
					HttpProtocolParams.setUseExpectContinue(params, false);

					ConnManagerParams.setTimeout(params, CONNMANAGER_TIMEOUT);
					ConnManagerParams.setMaxTotalConnections(params, MAX_TOTAL_CONNECTIONS);

					HttpConnectionParams.setConnectionTimeout(params, CONN_TIMEOUT);
					HttpConnectionParams.setSoTimeout(params, SO_TIMEOUT);

					SchemeRegistry schemeRegistry = new SchemeRegistry();
					schemeRegistry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
					schemeRegistry.register(new Scheme("https", SSLSocketFactory.getSocketFactory(), 443));
					ClientConnectionManager conMgr = new ThreadSafeClientConnManager(params, schemeRegistry);
					httpClient = new DefaultHttpClient(conMgr, params);
				}
			}
		}
		return httpClient;
	}

	public static CommandHttpResult post(String uri, BasicNameValuePair... params)
	{
		if (TextUtils.isEmpty(uri))
		{
			return null;
		}
		HttpResponse response = null;
		HttpPost httpPost = new HttpPost(uri);
		if (params != null)
		{
			List<NameValuePair> pairs = new ArrayList<NameValuePair>();
			for (int i = 0, count = params.length; i < count; i++)
			{
				if (params[i] != null)
				{
					pairs.add(params[i]);
				}
			}
			try
			{
				HttpEntity entity;
				entity = new UrlEncodedFormEntity(pairs, HTTP.UTF_8);
				httpPost.setEntity(entity);
			}
			catch (UnsupportedEncodingException e)
			{
				e.printStackTrace();
			}
		}

		try
		{
			response = getHttpClient().execute(httpPost);
		}
		catch (Exception e)
		{
			e.printStackTrace();
			return null;
		}

		if (response != null)
		{
			CommandHttpResult result = null;
			int statusCode = response.getStatusLine().getStatusCode();
			result = new CommandHttpResult();
			result.setStatusCode(statusCode);
			if (statusCode == HttpStatus.SC_OK)
			{
				HttpEntity httpEntity = response.getEntity();
				if (httpEntity != null)
				{
					try
					{
						result.setResult(EntityUtils.toString(httpEntity, HTTP.UTF_8));
					}
					catch (IOException e)
					{
						e.printStackTrace();
					}
				}
			}
			return result;
		}
		else
		{
			return null;
		}
	}
}
